package com.onsiteservice.admin.controller.service.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;

/**
 * <P></P>
 *
 * @author 李宁
 * @version v1.0
 * @since 2022/7/11 17:19
 */
@ApiModel("编辑维修工请求模型")
@Data
public class UpdateServiceWorkerDTO {

    @ApiModelProperty("维修工id")
    @NotNull(message = "请输入维修工id")
    private Long id;

    @ApiModelProperty("姓名")
    @NotBlank(message = "请输入维修工姓名")
    private String name;

    /**
     * 手机号
     */
    @ApiModelProperty("手机号")
    @NotBlank(message = "请输入维修工手机")
    @Pattern(regexp = "^1[3456789]\\d{9}$", message = "手机号格式不正确")
    private String phone;

}
